//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Aqua
#property indicator_color2  Orange


extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern int             FastMAPeriod    = 1;
extern int             SlowMAPeriod    = 34;
extern int             Signalperiod    = 5;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsEmail     = false;
extern bool            alertsNotify    = false;
extern bool            ArrowsOnFirstBar= false;

double      buffer1[],
buffer2[],
b2[],
b3[],
trend[];
string indicatorFileName;
bool   returnBars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0,b2); SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,3); SetIndexArrow(0,241);
   SetIndexBuffer(1,b3); SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,3); SetIndexArrow(1,242);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,trend);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=MathMin(Bars-counted_bars,Bars-1);
   if(returnBars) { b2[0]=MathMin(limit+1,Bars-1); return(0); }

//
//
//
//
//

   if(TimeFrame==Period())
     {
      for(i=limit;i>=0;i--) buffer1[i] = iMA(NULL,0,FastMAPeriod,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,SlowMAPeriod,0,MODE_SMA,PRICE_MEDIAN,i);
      for(i=limit;i>=0;i--)
        {
         buffer2[i]=iMAOnArray(buffer1,Bars,Signalperiod,0,MODE_LWMA,i);
         trend[i]=trend[i+1];
         if(buffer1[i]>buffer2[i]) trend[i]= 1;
         if(buffer1[i]<buffer2[i]) trend[i]=-1;

         //
         //
         //
         //
         //

         b2[i] = EMPTY_VALUE;
         b3[i] = EMPTY_VALUE;
         if(trend[i]!=trend[i+1])
            if(trend[i]==1)
               b2[i] = Low[i]-5*Point;
         else  b3[i] = High[i]+5*Point;
        }

      //
      //
      //
      //
      //

      if(alertsOn)
        {
         if(alertsOnCurrent)
            int whichBar=0;
         else     whichBar=1;
         if(trend[whichBar]!=trend[whichBar+1])
           {
            if(trend[whichBar] == 1) doAlert(whichBar,"buy");
            if(trend[whichBar] ==-1) doAlert(whichBar,"sell");
           }
        }
      return(0);
     }

//
//
//
//
//

   int shift=-1; if(ArrowsOnFirstBar) shift=1;
   limit= MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
     {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int x = iBarShift(NULL,TimeFrame,Time[i+shift]);
      if(x!=y)
        {
         b2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastMAPeriod,SlowMAPeriod,Signalperiod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,y);
         b3[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastMAPeriod,SlowMAPeriod,Signalperiod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,1,y);
        }
      else
        {

         b2[i] = EMPTY_VALUE;
         b3[i] = EMPTY_VALUE;
        }
     }
   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string timeFrameToString(int tf)
  {
   for(int i=ArraySize(iTfTable)-1; i>=0; i--)
      if(tf==iTfTable[i]) return(sTfTable[i]);
   return("");
  }
//
//
//
//
//

void doAlert(int forBar,string doWhat)
  {
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;

   if(previousAlert!=doWhat || previousTime!=Time[forBar])
     {
      previousAlert  = doWhat;
      previousTime   = Time[forBar];

      //
      //
      //
      //
      //

      message=StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+" SMA CrossOver ",doWhat);
      if(alertsMessage) Alert(message);
      if(alertsNotify) SendNotification(message);
      if(alertsEmail) SendMail(StringConcatenate(Symbol()," SMA CrossOver "),message);
      if(alertsSound) PlaySound("alert2.wav");
     }
  }
//+------------------------------------------------------------------+
